import aggregpacking${SUFFIX}
from aggregpacking${SUFFIX} import *

def testAggregate():
	pass # TODO
	testSphere()
	testEllipsoid()

def testSphere():
	pass

def testEllipsoid():
	print "Ellipsoid"
	e1 = Ellipsoid()
	e1 = Ellipsoid(Vector3(1,2,0),1,2,3)
	e1.ori = Quaternion(Vector3(0,0,1),.3)
	e2 = Ellipsoid(Vector3(0,0,0),1,.5,.7)
	e2.ori = Quaternion(Vector3(0,0,1),-.2)
	v1 = e1.computeNearestPointFrom(Vector3(0,0,0))
	print v1,e1.containsPoint(v1),e1.computeRelativeDistanceFrom(v1)
	e1.computeDistanceFrom(e2)
	print e1
	#
	e1 = Ellipsoid(Vector3(0,0,0),1,1,1)
	e2 = Ellipsoid(Vector3(3,4,0),2,2,2)
	print e1.computeDistanceFrom(e2)
	e1.ori = Quaternion(1,2,3,4)
	e2.ori = Quaternion(2,3,4,5)
	print e1.computeDistanceFrom(e2)

def testRandomizer():
	print randomizer, randomizer.random()
	fr = FullerCurveRandomizer(10,.5,"/tmp/aggregSizeRansomizer.txt",.5e-3,16e-3)
	print fr.sizes
	for s in fr.sizes: print s

def testConcreteMixture():
	print ConcreteMixture()
	pass

def testHeteroGeom(full=False,plot=False,save=False):
	r = FullerCurveRandomizer(10,.5,4e-3,8e-3)
	r.seed = random.randint(0,10000)
	print r,r.seed
	cm = ConcreteMixture()
	print cm
	hg = HeteroGeometry(25e-3,r,cm)#,"/tmp/hetergeom.dat")
	print hg,hg.check()
	a = hg.aggregates
	print a[1],a[1]
	for i in a: pass
	print i
	if plot:
		hg.plot()
	#
	if full:
		r = FullerCurveRandomizer(10000,.5,.5e-3,16e-3,"/tmp/fullercurve.dat")
		print r,r.seed
		import time
		t = time.time()
		hg = HeteroGeometry(50e-3,r,cm,"/tmp/hetergeom2.dat")
		print 'Elapsed time: %g'%(time.time()-t)
		print hg,'checking...,'
		#print hg.check(),len(hg.aggregates)
		print len(hg.aggregates)
		if plot:
			hg.plot()
		if save:
			f = open('/tmp/aggregs.dat','w')
			for a in hg.aggregates:
				p = a.pos
				f.write('%e %e %e %e\n'%(p.x,p.y,p.z,a.size))
			f.close()

def testOctree():
	o = Octree(0,0,0,8.8,3)
	r = o.root
	print o,o.size,o.depth,o.center,o.root,r.isRoot,r.number
	children = r.children
	print children
	for n in children: print n,n.number,n.x,n.y,n.z,n.size
	for ch2 in children: pass
	print n,n.size,n.level,n.center,n.data,n.parent,n.children,n.isLeaf,n.isRoot
	print n.root,r,n.root==n,n.root==r
	print len(n.getChildrenIntersectingBox(0,0,0,20)), len(n.getChildrenIntersectingBox(0,0,0,1e-1)), len(n.getChildrenIntersectingBox(0,2.2,2.2,1.5))
	print o
	for n in o: pass
	print n,n.level,n.number
	print len([n for n in o]),len(o)
	s = Sphere(Vector3(0,2.2,2.2),.5*1.5)
	o.addData(s)
	for n in o:
		if len(n.data):
			print n,n.level,n.number,n.center
	if 0:
		o.plot()
		o.plot(onlyLevel=2)
	s2 = Sphere(Vector3(-2.2,-2.2,-2.2),.1)
	print len(o.getPotentialNeighbors(s)),len(o.getPotentialNeighbors(s2))

def test():
	print 'TESTING LIBAGGREGPACKING'
	testAggregate()
	#testRandomizer()
	#testConcreteMixture()
	#testHeteroGeom(plot=True,full=True)
	#testOctree()
	#testHeteroGeom(full=True,plot=False,save=True)
